// Title: Earbud Box
// Author: http://www.thingiverse.com/Jinja
// Date: 23/12/2012

/////////// START OF PARAMETERS /////////////////

iwidth = 35;
idepth = 16;
iheight = 16;
theight = 5;
theight2 = 5;
wall = 2.5;
radius = 4;
wrap_height = 20;
wire_width = 1.8;

/////////// END OF PARAMETERS /////////////////

$fs=0.3;

lip = 4;

difference()
{
	headphone_protect();
//	cube([50,50,50]);
	translate([0,17,30.5+wall])
	cube([8,40,61], true);
	for(x=[-iwidth*0.4:(iwidth*0.8)/3:iwidth*0.41])
	{
		translate([x,(idepth+wire_width)*0.5+wall,0] )
		hole();
		translate([x,-((idepth+wire_width)*0.5+wall),0] )
		rotate([0,0,180])
		hole();
	}

	for(y=[-idepth*0.3:idepth*0.6:idepth*0.3])
	{
		translate([(iwidth+wire_width)*0.5+wall,y,0] )
		rotate([0,0,-90])
		hole();
		translate([-((iwidth+wire_width)*0.5+wall),y,0] )
		rotate([0,0,90])
		hole();
	}

}

module hole()
{
	cylinder( wall, wire_width*0.5, wire_width*0.5 );
	translate([-wire_width*0.5,0,0] )
	cube( [wire_width, 10, wall] );
}

module headphone_protect()
{
	rounded_box( iwidth+wall+(2*lip), idepth+wall+(2*lip), wall, radius+lip );
	hollow_rounded_box( iwidth, idepth, iheight, radius, wall );

	translate([0,0,iheight])
	difference()
	{
		rounded_taper3( iwidth+5+(2*wall), idepth+5+(2*wall), theight, iwidth+(2*wall), idepth+(2*wall), radius+wall );
		rounded_taper3( iwidth+5, idepth+5, theight, iwidth, idepth, radius );
	}

/*	difference()
	{
		translate([0,0,iheight])
		rounded_taper( iwidth+2*wall, idepth+2*wall, theight, radius+wall );
		translate([0,0,iheight-4])
		rounded_taper( iwidth+2*wall, idepth+2*wall, theight, radius+wall );
	}*/
/*	translate([0,0,iheight+theight])
	rounded_box( iwidth-idepth, radius*2, wrap_height, radius );
	translate([0,0,iheight+theight+wrap_height])
	rounded_taper2( iwidth-10, idepth-5, theight2, iwidth-idepth, radius );*/
}

module rounded_taper( iwidth, idepth, iheight, radius )
{
	hull()
	{
		rounded_box( iwidth, idepth, 1, radius );
		translate([0,0,iheight])
		rounded_box( iwidth-idepth, radius, 1, radius*0.5 );
	}
}

module rounded_taper2( iwidth, idepth, iheight, iwidth2, radius )
{
	hull()
	{
		rounded_box( iwidth2, radius*2, 1, radius );
		translate([0,0,iheight])
		rounded_box( iwidth, idepth, 1, radius );
	}
}

module rounded_taper3( iwidth, idepth, iheight, iwidth2, idepth2, radius )
{
	hull()
	{
		rounded_box( iwidth2, idepth2, 1, radius );
		translate([0,0,iheight])
		rounded_box( iwidth, idepth, 1, radius );
	}
}



module hollow_rounded_box( iwidth, idepth, iheight, radius, wall )
{
	difference()
	{
		rounded_box( iwidth+2*wall, idepth+2*wall, iheight, radius+wall );
		rounded_box( iwidth, idepth, iheight, radius );
	}
}

module rounded_box( iwidth, idepth, iheight, radius )
{
	hull()
	{
		translate([-(iwidth*0.5)+radius,-(idepth*0.5)+radius,0])
		cylinder( iheight, radius, radius );
		translate([(iwidth*0.5)-radius,-(idepth*0.5)+radius,0])
		cylinder( iheight, radius, radius );
		translate([-(iwidth*0.5)+radius,(idepth*0.5)-radius,0])
		cylinder( iheight, radius, radius );
		translate([(iwidth*0.5)-radius,(idepth*0.5)-radius,0])
		cylinder( iheight, radius, radius );
	}
}